<?php
namespace Common\Service;

/**
 * Cookie 服务，对外提供的服务如下
 */

class CookieService
{
    private $_key_prefix = 'KD_';
    /***************************************************************************************************************************************************************************
     * 玩家登陆信息
     ***************************************************************************************************************************************************************************/
    /**
     * 设置玩家登陆信息
     * @param type $_playerId
     * @param type $_key
     */
    public function setPlayerMarkCookieForLogin($_playerId,$_key,$_gameId)
    {
        /*
         * 每个游戏都存在一个登录信息
         * 1、设置player id
         * 2、设置加密key字段
         */
        
        $key = cookie($this->_key_prefix.'key');    //  当前客户端全局加密key
        if(isVarEmpty($key))
        {
            //  客户端不存在cookie-key，属于第一次设置cookie
            cookie('key',$_key,array('prefix'=>$this->_key_prefix,'expire'=>60*60));  //  playerId的加密秘钥
            $key = $_key;
        }
        $gameInfoKey = 'gameKey_'.$_gameId; //  当前游戏的信息记录KEY
        $gameInfoVal = authcode($_playerId,'ENCODE',$key);
        cookie($gameInfoKey,$gameInfoVal,array('prefix'=>$this->_key_prefix,'expire'=>60*60));  //  playerId的加密秘钥
    }
    /**
     * 提取玩家登录信息COOKIE
     * @param type $_game_id
     * @return type 
     */
    public function getPlayerMarkCookieForLogin($_game_id)
    {
        /*
         * 系统将在玩家客户端记录游戏的登录信息
         * 每个游戏都有一个登录信息（palyerKey/playerMark）
         * key = keyval
         * game = key_mark
         */
        $key = cookie($this->_key_prefix.'key');    //  当前客户端全局加密key
        $palyerId = cookie($this->_key_prefix.'gameKey_'.$_game_id); //  当前游戏的信息记录KEY
        if(!isVarEmpty($key) && !isVarEmpty($palyerId))
        {
            return array('playerKey'=>$key,'playerMark'=>$palyerId);
        }
        
        return false;
    }
}