<?php
namespace Common\Service;

/**
 * Session 服务，对外提供的服务如下
 */

class SessionService
{
    /***************************************************************************************************************************************************************************
     * 用于支付相关处理
     ***************************************************************************************************************************************************************************/
    /**
     * 设置当前用户支付的订单号
     * @param type $_orderId
     */
    public static function setOrderIdForPaySelect($_orderId)
    {
        session('order_id',$_orderId);
    }
    /**
     * 查询当前用户支付的订单号
     */
    public static function getOrderIdForPaySelect()
    {
        $orderId = session('order_id');
        if(isVarEmpty($orderId))
        {
            return false;
        }
        return $orderId;
    }
    /***************************************************************************************************************************************************************************
     * 登录请求授权状态处理部分
     ***************************************************************************************************************************************************************************/
    /**
     * 设置游戏授权验证状态（已授权）
     * @param type $_game_id
     * @param type $_channel
     */
    public static function setGameAuthorizedStatus($_game_id,$_channel)
    {
        session('GAME.ID',$_game_id);
        session('GAME.CHANNEL',$_channel);
    }
    /**
     * 查询游戏登录授权状态
     * @return boolean
     */
    public static function getGameAuthorizedStatus()
    {
        $gameId = session('GAME.ID');
        if($gameId)
        {
            return $gameId;
        }
        return false;
    }
    /**
     * 查询游戏登录授权状态
     * @return boolean
     */
    public static function removeGameAuthorizedStatus()
    {
        session('GAME.ID',null);
    }
}