<?php
namespace Home\Controller;
use Think\Controller;
use Home\Utils\LogUtil;

/**
 * 基础控制器，内容如下
 * 1、空操作默认处理
 * 2、错误信息展示页面
 */
class BaseController extends Controller {
    const PROJECT_NAME ="ylc.llewan.com";

    //任务数据列表
	public $taskList = array(
        'click_game'=>array(
            'title'=>'玩游戏赚玩币'
            ,'type'=>'click_game'
            ,'icon'=>'task/click_game.png'
            ,'list'=>array(
                array(
                    'ch_name'=>'玩任意1款游戏'
                    ,'en_name'=>'click_game1'
                    ,'target'=>'1'
                    ,'schedule'=>'0'
                    ,'gold'=>'50'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'玩任意3款游戏'
                    ,'en_name'=>'click_game3'
                    ,'target'=>'3'
                    ,'schedule'=>'0'
                    ,'gold'=>'100'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'玩任意10款游戏'
                    ,'en_name'=>'click_game10'
                    ,'target'=>'10'
                    ,'schedule'=>'0'
                    ,'gold'=>'500'
                    ,'status'=>'1'
                )
            )
        )
        ,'invite_user'=>array(
            'title'=>'邀请新伙伴'
            ,'type'=>'invite_user'
            ,'icon'=>'task/invite_user.png'
            ,'list'=>array(
                array(
                    'ch_name'=>'邀请1位新伙伴'
                    ,'en_name'=>'invite_user1'
                    ,'head'=>'https://res.g.llewan.com/zuiqiangyoulechang/task/moren.png'
                    ,'target'=>'1'
                    ,'schedule'=>'0'
                    ,'gold'=>'500'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'邀请2位新伙伴'
                    ,'en_name'=>'invite_user2'
                    ,'head'=>'https://res.g.llewan.com/zuiqiangyoulechang/task/moren.png'
                    ,'target'=>'2'
                    ,'schedule'=>'0'
                    ,'gold'=>'750'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'邀请3位新伙伴'
                    ,'en_name'=>'invite_user3'
                    ,'head'=>'https://res.g.llewan.com/zuiqiangyoulechang/task/moren.png'
                    ,'target'=>'3'
                    ,'schedule'=>'0'
                    ,'gold'=>'1000'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'邀请4位新伙伴'
                    ,'en_name'=>'invite_user4'
                    ,'head'=>'https://res.g.llewan.com/zuiqiangyoulechang/task/moren.png'
                    ,'target'=>'4'
                    ,'schedule'=>'0'
                    ,'gold'=>'1500'
                    ,'status'=>'1'
                )
                ,array(
                    'ch_name'=>'邀请5位新伙伴'
                    ,'en_name'=>'invite_user5'
                    ,'head'=>'https://res.g.llewan.com/zuiqiangyoulechang/task/moren.png'
                    ,'target'=>'5'
                    ,'schedule'=>'0'
                    ,'gold'=>'2000'
                    ,'status'=>'1'
                )
            )
        )

    );

    //签到数据列表
    public $signList = array(
            array('day'=>'第一天','gold'=>50,'status'=>1)
            ,array('day'=>'第二天','gold'=>80,'status'=>1)
            ,array('day'=>'第三天','gold'=>120,'status'=>1)
            ,array('day'=>'第四天','gold'=>150,'status'=>1)
            ,array('day'=>'第五天','gold'=>200,'status'=>1)
            ,array('day'=>'第六天','gold'=>250,'status'=>1)
            ,array('day'=>'第七天','gold'=>500,'status'=>1)
    );
	
	function _initialize()
	{
        LogUtil::input(self::PROJECT_NAME);//记录日志

        C('taskList',$this->taskList);//设置任务数据列表
        C('signList',$this->signList);//签到数据列表
    }
    
	
	//重写display,加入记录输出代码
	public function display($templateFile='',$charset='',$contentType='',$content='',$prefix=''){
		$logdata = $this->get();
	
		LogUtil::output($logdata);
	
		$this->view->display($templateFile,$charset,$contentType,$content,$prefix);
	}
	
    /**
     * 空操作请求默认处理
     */
    protected function _empty()
    {
        echo 'bad request...';
    }
    /**
     * 获取请求信息
     */
    protected function getReqData()
    {
        $srcData = file_get_contents('php://input');
        
        if(getClientRealIp() === '127.0.0.1')
        {
            $srcData = '{"app_version": "1.0", "source": "QQ", "nickname": "劉新俊", "device_type": "ios", "channel_id": "14705", "device_model": "iPhone", "headimgurl": "http://qzapp.qlogo.cn/qzapp/101402694/F643B6603F98A017CEAEC3460B4552E0/100", "sign": "8dcedd4e9bf762cd84b75da90d1dce1f", "os_version": "ios:10.0", "game_id": "626526", "openid": "F643B6603F98A017CEAEC3460B4552E0", "device_id": "2DD34BC3-5038-498E-9237-766345DD306B", "sex": "0"}';
        }
        if(!isVarEmpty($srcData))
        {
            try
            {
                return json_decode($srcData,true);
            }
            catch (\Think\Exception $e)
            {
                return array();
            }
        }
        return array();
    }
    /**
     * 【格式化处理结果】
     * 
     * 输入
     *  标准的Result处理结果
     * 
     * 输出
     *  json格式的字符串
     */
    protected function formatRes($result)
    {
       
        if(empty($result))
        {
            $result['c']=0;
           
        }else if($result['c']==2)
        {
        
            //数据为空
          
        }else
        {
            $result['c']=1;
        }
        return json_encode($result);
    }
   
}