<?php
namespace Home\Controller;
use Think\Controller;
/*
* 游戏控制器
*
*/
class GameController extends BaseController
{

    //游戏列表
    public function gameList()
    {
        $game = I('game','zuiqiangyoulechang');
        //获取数量（分页）
        $size = I('size',10);
        $page = I('page',1);
        $skip = $size * ($page-1);
        
        $redis = S(C('REDIS'));
        $id = $redis->ZREVRANGE($game.'_game_id',$skip,$skip+$size-1);
        if(empty($id)) {
            $flushObj =  new \Home\Controller\FlushController();
            $id = $flushObj->game($game,$skip,$skip+$size-1);
        }
        foreach($id as $key=>$val) {
            $arr = json_decode($redis->hget($game.'_game_list',$val),true);

            if($arr['status'] == 1) {
                $gameList[]  = array(
                    'id'=>$arr['sysid']
                    ,'gamer'=>$arr['gamer']
                    ,'name'=>$arr['name']
                    ,'ad'=>$arr['ad']
                    ,'icon'=>$arr['icon']
                    ,'appid'=>$arr['appid']
                    ,'gourl'=>$arr['gourl']
                    ,'intro'=>$arr['intro']
                );
            }
        }

        if(!empty($gameList)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'gameList'=>$gameList
                )
            );
        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'暂无数据'
            );
        }

        echo $this->formatRes($result);
    }

    //游戏点击记录
    public function clickCount()
    {
        $model= new \Home\Model\GameModel();
        $token = decryptToken(I('token'));
        $gid = I('gid');

        if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
            );
        } else {
            if(empty($gid)){
                $result = array(
                    'c'=>2
                    ,'msg'=>'游戏不能为空'
                );
			} else {
                //记录游戏点击数据
                $result = $model->clickCount($token['uid'],$gid);
            }

        }
        echo $this->formatRes($result);
    }


    //用户游戏列表（玩过游戏）
    public function userGame()
    {
        $token = decryptToken(I('token'));
        $gid = I('gid');

        if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
            );
        } else {
            $model= M("yl_member_game","",C("LEWAN_HEZI"));
            $uid = $token['uid'];
             //获取数量（分页）
            $size = I('size',10);
            $page = I('page',1);
            $skip = $size * ($page-1);
        
            // $model = $model->join('left join yl_game on yl_game.sysid=yl_member_game.r_game');
            // $where = array(
            //     'yl_member_game.uid'=>$uid
            //     ,'yl_game.status'=>1
            // );
            // $field = 'yl_game.sysid as id,yl_game.name,yl_game.icon,yl_game.appid,yl_game.gourl,yl_game.gamer';
            // $gameList = $model->where($where)->limit($skip,$size)->order('yl_member_game.create_time desc')->field($field)->select();
            
            $gameList = $model->where(array('uid'=>$uid))->limit($skip,$size)->order('yl_member_game.create_time desc')->field('r_game')->select();
            if(!empty($gameList)) {
                $redis = S(C('REDIS'));
                foreach($gameList as $key=>$val) {
                    $arr = json_decode($redis->hget('ylc_game_list',$val['r_game']),true);
        
                    if($arr['status'] == 1) {
                        $gameArr[]  = array(
                            'id'=>$arr['sysid']
                            ,'gamer'=>$arr['gamer']
                            ,'name'=>$arr['name']
                            ,'icon'=>$arr['icon']
                            ,'appid'=>$arr['appid']
                            ,'gourl'=>$arr['gourl']
                            ,'typeList'=>$arr['typeList']
                            ,'labelList'=>$arr['labelList']
                        );
                    }
                }
                $gameList = $gameArr;

                // $model= new \Home\Model\GameModel();
                // $gameId = array();
                // foreach($gameList as $key=>$val) {
                //     $gameId[] = $val['id'];
                //     $gameList[$key]['typeList'] = array();
                //     $gameList[$key]['labelList'] = array();
                // }
                // //处理分类和标签数据
                // if(!empty($gameId)) {
                //     $gameType = $model->type($gameId);
                //     $gameLabel = $model->label($gameId);
                //     if (!empty($gameType) || !empty($gameLabel)) {
                //         foreach ($gameList as $key => $val) {
                //             if (!empty($gameType)) {
                //                 foreach ($gameType as $tkey => $tval) {
                //                     if ($val['id'] == $tval['r_game']) {
                //                         $gameList[$key]['typeList'][] = $tval;
                //                     }
                //                 }
                //             }
                //             if (!empty($gameLabel)) {
                //                 foreach ($gameLabel as $lkey => $lval) {
                //                     if ($val['id'] == $lval['r_game']) {
                //                         $gameList[$key]['labelList'][] = $lval;
                //                     }
                //                 }
                //             }
                //         }
                //     }
                // }

                $result = array(
                    'c'=>1
                    ,'msg'=>'获取成功'
                    ,'d'=>array(
                        'gameList'=>$gameList
                    )
                );
            } else {
                $result = array(
                    'c'=>2
                    ,'msg'=>'暂无数据'
                );
            }
        }
        echo $this->formatRes($result);
    }


    //用户推荐游戏列表（没玩过游戏）
    public function userRecommend()
    {
        $token = decryptToken(I('token'));

        if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
            );
        } else {
            $uid = $token['uid'];
            $userGame = M("yl_member_game","",C("LEWAN_HEZI"))->where(array('uid'=>$uid))->field('r_game')->select();

            $where = array('status'=>1);
            if(!empty($userGame)) {
                $gameId = array_column($userGame,'r_game');
                $where['sysid'] = array('not in',$gameId);
            }
            
            $gameList = M("yl_game","",C("LEWAN_HEZI"))->where($where)->field('sysid,name,gamer,icon,appid,gourl')->order('rand()')->limit(4)->select();

            if(empty($gameList)) {
                $gameList = M("yl_game","",C("LEWAN_HEZI"))->where(array('status'=>1))->field('sysid,name,gamer,icon,appid,gourl')->order('rand()')->limit(4)->select();
            }
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'gameList'=>$gameList
                )
            );
        }
        echo $this->formatRes($result);
    }


    //主题列表
    public function themeList()
    {
        $redis = S(C('REDIS'));
        $id = $redis->ZREVRANGE('ylc_gametheme_id',0,-1);

        foreach($id as $key=>$val) {
            $arr = json_decode($redis->hget('ylc_gametheme_list',$val),true);

            if($arr['status'] == 1) {
                $gameTheme[]  = array(
                    'id'=>$arr['sysid']
                    ,'name'=>$arr['name']
                    ,'game_list'=>$arr['gameList']
                );
            }
        }

        if(!empty($gameTheme)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'themeList'=>$gameTheme
                )
            );
        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'暂无数据'
            );
        }

        // $gameTheme = M("yl_game_theme","",C("LEWAN_HEZI"))->where(array('status'=>1))->field('sysid as id,name,game_list')->order('sort desc')->select();
        // if(!empty($gameTheme)) {
        //     $gameField = 'sysid as id,name,icon,appid,gourl';
        //     foreach($gameTheme as $key=>$val) {
        //         $gameId = explode(',',$val['game_list']);
        //         if(!empty($gameId)) {

        //             $gameTheme[$key]['game_list'] = M("yl_game","",C("LEWAN_HEZI"))->where(array('status'=>1,'sysid'=>array('in',$gameId)))->field($gameField)->order('field(sysid, '.$val['game_list'].')')->select();
        //         } else {
        //             $gameTheme[$key]['game_list'] = array();
        //         }
        //     }
        //     $result = array(
        //         'c'=>1
        //         ,'msg'=>'获取成功'
        //         ,'d'=>array(
        //             'themeList'=>$gameTheme
        //         )
        //     );
        // } else {
        //     $result = array(
        //         'c'=>2
        //         ,'msg'=>'暂无数据'
        //     );
        // }

        echo $this->formatRes($result);
    }



}

?>