<?php
namespace Home\Controller;
use Think\Controller;
/*
* 广告控制器
*
*/
class ShopController extends BaseController
{

    //公告列表
    public function noticeList()
    { 
        $noticeArr = array(
            'Json成功兑换了修容七件套'
            ,'Allen成功兑换了便携小兔玻璃杯'
            ,'Chip成功兑换了大猪蹄子抱枕'
            ,'能能成功兑换了修容七件套'
            ,'烟雨成功兑换了便携小兔玻璃杯'
            ,'馒头成功兑换了时尚灯泡玻璃杯'
            ,'安晓苏成功兑换了1.2米超大型公仔熊'
            ,'Silver Nong成功兑换了精灵宝贝的移动电源'
        );
        $orderModel = M("yl_goods_order","",C("LEWAN_HEZI"))->join('left join game_member on game_member.uid=yl_goods_order.uid');
        $orderArr = $orderModel->where(array('status'=>array('gt',1)))->order('create_time')->field('game_member.user_nickname,yl_goods_order.name')->limit(50)->select();
        if(!empty($orderArr)) {
            foreach($orderArr as $key=>$val) {
                $content = emoji_decode($val['user_nickname']).'成功兑换了'.$val['name'];
                array_unshift($noticeArr,$content);
            }
        }
        $result = array(
            'c'=>1
            ,'msg'=>'获取成功'
            ,'d'=>array(
                'list'=>$noticeArr
            )
        );


        echo $this->formatRes($result);
    }


    //商品列表
    public function goodsList()
    { 
        $isShow = I('is_show');
        //获取数量（分页）
		$size = I('size',20);
		$page = I('page',1);
		$skip = $size * ($page-1);

        $redis = S(C('REDIS'));
        if($isShow == 1) {
            $id = $redis->ZREVRANGE('ylc_goods_id',0,-1);
        } else {
            $id = $redis->ZREVRANGE('ylc_goods_id',$skip,$skip+$size-1);
        }
        foreach($id as $key=>$val) {
            $arr = json_decode($redis->hget('ylc_goods_list',$val),true);

            $show = true;
            if($isShow == 1) {
                $show = $arr['is_show'] == 1;
            } 
            if($arr['status'] == 1 && $show) {
                $goodsArr[]  = array(
                    'id'=>$arr['sysid']
                    ,'name'=>$arr['name']
                    ,'icon'=>$arr['icon']
                    ,'price'=>$arr['initial_price']
                    ,'stock'=>$arr['stock']
                    ,'change_way'=>$arr['change_way']
                    ,'type'=>$arr['type']
                );
            }
        }

        // $whereArr = array(
        //     'status'=>1
        // );
        // if($isShow == 1) {
        //     $whereArr['is_show'] = $isShow;
        // }
        // $field = 'sysid as id,name,icon,initial_price as price,stock,change_way,type';
        // $goodsArr = M("yl_goods","",C("LEWAN_HEZI"))->where($whereArr)->field($field)->limit($skip,$size)->order('sort desc')->select();
        if(!empty($goodsArr)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'list'=>$goodsArr
                )
            );

        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'暂无数据'
            );
        }

        echo $this->formatRes($result);
    }


    //用户商品列表
    public function userGoods()
    { 
        $token = decryptToken(I('token'));
        //获取数量（分页）
		$size = I('size',10);
		$page = I('page',1);
		$skip = $size * ($page-1);

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
        }
        
        $whereArr = array(
            'status'=>1
        );
        if($isShow == 1) {
            $whereArr['is_show'] = $isShow;
        }
        $field = 'sysid as order_id,goods_id,name,icon,gold,status,create_time,goods_type,redeem_code';
        $orderArr = M("yl_goods_order","",C("LEWAN_HEZI"))->where(array('uid'=>$token['uid']))->field($field)->limit($skip,$size)->order('create_time desc')->select();
        if(!empty($orderArr)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'list'=>$orderArr
                )
            );

        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'暂无数据'
            );
        }

        echo $this->formatRes($result);
    }


    //商品兑换
    public function goodsChange()
    { 
		$token = decryptToken(I('token'));
		$goodsId = I('goods_id');
		$changeWay = I('change_way');

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($goodsId)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数不存在'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($changeWay)) {
            $result = array(
                'c'=>2
                ,'msg'=>'change_way参数不存在'
			);
			echo $this->formatRes($result);exit;
		}

        $num = M("yl_goods_order","",C("LEWAN_HEZI"))->where(array('uid'=>$token['uid'],'create_time'=>array('gt',date('Y-m-d'))))->count();
        if($num > 2) {
            $result = array(
                'c'=>2
                ,'msg'=>'今天兑换次数已达上限'
			);
			echo $this->formatRes($result);exit;
        }

        $model= new \Home\Model\ShopModel();
        $result = $model->goodsChange($token['uid'],$goodsId,$changeWay);


        echo $this->formatRes($result);
    }

}

?>