<?php
namespace Home\Model;

class GameModel extends BaseModel
{

    //获取游戏列表
    function getData()
    {
    
        $result = Array();
        
        //获取数量（分页）
		$size = I('size',10);
		$page = I('page',1);
		$skip = $size * ($page-1);

        $field = 'sysid as id,name,gamer,ad,appid,gourl';
        $gameList = M("yl_game","",$this->__lewan_hezi)->where(array('status'=>1))->field($field)->limit($skip,$size)->order('sort desc')->select();

        if(!empty($gameList)) {
            $result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
                    'gameList'=>$gameList
                )
            );
        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'暂无数据'
            );
        }

        
        return $result;
    }

    function type($gameId = array()) {
        $model = M("yl_game_class","",$this->__lewan_hezi);
        if(!empty($gameId)) {
            $where = array('yl_game_class_list.r_game'=>array('in',$gameId));
            $model = $model->join('left join yl_game_class_list on yl_game_class.sysid=yl_game_class_list.r_class');
            $list = $model->where($where)->field('yl_game_class_list.r_class,yl_game_class_list.r_game,yl_game_class.name')->select();
        } else {
            $list = $model->field('sysid,name')->select();
        }
        return $list;
    }

    function label($gameId = array()) {
        $model = M("yl_game_label","",$this->__lewan_hezi);
        if(!empty($gameId)) {
            $where = array('yl_game_label_list.r_game'=>array('in',$gameId));
            $model = $model->join('left join yl_game_label_list on yl_game_label.sysid=yl_game_label_list.r_label');
            $list = $model->where($where)->field('yl_game_label_list.r_label,yl_game_label_list.r_game,yl_game_label.name')->select();
        } else {
            $list = $model->field('sysid,name')->select();
        }
        return $list;
    }

    //游戏点击记录
    function clickCount($uid,$gid)
    {
        $result = Array();
        $taskList = C('taskList');
        $class = I('classify');
        $type = I('type');
        $pos = I('pos');

        $memberModel = M("yl_member_game","",$this->__lewan_hezi);
        $memberModel->startTrans();

        //记录用户游戏列表数据
        $memberWhere = array(
            'uid'=>$uid
            ,'r_game'=>$gid
        );
        $gameNum = $memberModel->where($memberWhere)->count();
        if($gameNum > 0) {
            $re1 = $memberModel->where($memberWhere)->setInc('num',1);
        } else {
            $memberkAdd = array(
                'uid'=>$uid
                ,'r_game'=>$gid
                ,'create_time'=>date('Y-m-d H:i:s')
            );
            $re1 = $memberModel->add($memberkAdd);
        }

        //游乐场游戏点击数据表
        $clickArr = array(
            'uid'=>$uid
            ,'r_game'=>$gid
            ,'create_time'=>date('Y-m-d H:i:s')
            ,'class'=>$class
            ,'type'=>$type
            ,'position'=>$pos
        );
        $re2 = M("yl_game_onclick_log","",$this->__lewan_hezi)->add($clickArr);

        //游乐场游戏点击数更新
        $re3 = M("yl_game","",$this->__lewan_hezi)->where(array('sysid'=>$gid))->setInc('true_num',1);

        if($re1 && $re2 && $re3) {
            $memberModel->commit();

            /*------------------------------------玩游戏任务记录------------------------------------*/
            $taskModel  = M("yl_game_task","",$this->__lewan_hezi);
            // $taskEnName = $taskList[0]['en_name'];
            // $taskChName = $taskList[0]['ch_name'];
            //获取用户今天做任务数据
            // $sql = "select * from ".get_table("game_global_task")." where uid=$uid and en_name='$taskEnName' and add_time > '".date('Y-m-d')."' order by add_time desc";
            // $result = $GLOBALS["conn"]->Query($sql);
            // $taskArr = $GLOBALS["conn"]->getOne($result);
            $whereArr = array(
                'uid'=>$uid
                ,'type'=>'click_game'
                ,'game_code'=>'zuiqiangyoulechang'
                ,'add_time'=>array('gt',date('Y-m-d'))
            );
            $taskArr = $taskModel->where($whereArr)->find();

            if(!empty($taskArr)) {
                //更新今日任务进度
                // $tupdateArr = array(
                //     'schedule'=>'schedule+1'
                // );
                $receiveArr = json_decode($taskArr['receive_info'],true);

                $taskModel->where($whereArr)->setInc('schedule',1);

                if($taskArr['schedule'] >= 2 && $receiveArr['click_game3']['status'] == 1) {
                    $receiveArr['click_game3']['status'] = 2;
                    $taskModel->where($whereArr)->save(array('receive_info'=>json_encode($receiveArr)));
                }
                if($taskArr['schedule'] >= 9 && $receiveArr['click_game10']['status'] == 1) {
                    $receiveArr['click_game10']['status'] = 2;
                    $taskModel->where($whereArr)->save(array('receive_info'=>json_encode($receiveArr)));
                }
                
                // $twhere =" and uid=$uid and en_name='$taskEnName' and add_time > '".date('Y-m-d')."'";
                // update_record($GLOBALS["conn"],'game_global_task',$tupdateArr,'',$twhere);

            } else {
                $receiveArr = array(
                    'click_game1'=>array('status'=>2)
                    ,'click_game3'=>array('status'=>1)
                    ,'click_game10'=>array('status'=>1)
                );
                //添加今日任务记录
                $taddArr = array(
                    "uid" 	=> $uid
                    ,"en_name" => 'click_game'
                    ,"ch_name" => '点击游戏'
                    ,'add_time'=>date('Y-m-d H:i:s')
                    ,'add_ip'=>$ip
                    ,'type'=>'click_game'
                    ,'game_code'=>'zuiqiangyoulechang'
                    ,'receive_info'=>json_encode($receiveArr)
                );
                // add_record($GLOBALS["conn"],'game_global_task',$taddArr);
                $taskModel->where($whereArr)->add($taddArr);
            }
            
            $result = array(
                'c'=>1
                ,'msg'=>'保存成功'
            );

        } else {
            $result = array(
                'c'=>2
                ,'msg'=>'保存失败'
            );
        }
        
        return $result;
    }
    
}