<?php
namespace Org\Util;

class NotifyUtils
{
	const EMAIL_API_URL = 'http://notify.guoziyx.com/index.php/SendEmail/send/';//发送邮件接口地址
	const MSG_API_URL = 'http://notify.guoziyx.com/index.php/SendMessage/send/';//发送消息接口地址
	

	public $emailClsPath;  //发送邮件类所在目录
	public $msgClsPath;   //发送短信类所在目录
	
	/*public function __construct(){
		$this->emailClsPath  = APP_PATH.'/Home/PHPMailer/';
		$this->msgClsPath  = APP_PATH.'/Home/SMS/';
	}*/
	
	/*
	 * 调用项目发送邮件接口发送邮件
	 * @param array $params 请求参数
	 * @param string $request_type 请求方法
	 * @param string $url 请求接口地址
	 * 
	 */
	public static function apiSendEmail($params,$request_type='post',$url=''){
		$apiUrl = $url ? $url : self::EMAIL_API_URL;
		
		if(strtolower($request_type) == 'get'){
			$ret = self::curlGet($apiUrl,$params);
		}else{
			$ret = self::curlPost($apiUrl,$params);
		}

		return $ret;
	}
	
	/*
	 * 调用项目发送邮件接口发送邮件
	 * @param array $params 请求参数
	 * @param string $request_type 请求方法
	 * @param string $url 请求接口地址
	 *
	 */
	public static function apiSendMsg($params,$request_type='post',$url=''){
		$apiUrl = $url ? $url : self::MSG_API_URL;
	
		if(strtolower($request_type) == 'get'){ 
			$ret = self::curlGet($apiUrl,$params);
		}else{
			$ret = self::curlPost($apiUrl,$params);
		}
	
		return $ret;
	}
	
	/*
	* 返回数据函数
	* @param int $errcode 错误代码,0表示ok，非0表示报错
	* @param string $msg 错误提示  
	* @param mixed  $data 返回的数据
	* @encode boolean 是否json_encode
	*/
	static public function returnMsg($errcode=1000,$msg='fail',$data='',$encode=true){
			$ret = array('errcode'=>$errcode,'msg'=>$msg,'data'=>$data?$data:'');
			 
			return $encode ? json_encode($ret,JSON_UNESCAPED_UNICODE) : $ret;
	}
	
	
	/**
	 * 发起http GET请求，并返回数据
	 * @param type $uri
	 * @param mixed params 请求参数
	 * @return type
	 */
	static public function curlGet($uri,$params=array())
	{
		if($params){
			if(is_array($params)){
				$query = http_build_query($params);
			}else{
				$query = $params;
			}
			
			$join = strpos($uri,'?') ? '&' : '?';
			$url = $uri.$join.$query;
		}
		
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true) ; // 获取数据返回
		curl_setopt($ch, CURLOPT_BINARYTRANSFER, true) ; // 在启用 CURLOPT_RETURNTRANSFER 时候将获取数据返回
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		$ret = curl_exec($ch);
		curl_close($ch);
	
		return $ret;
	}
	
	/**
	 * 发起http POST请求，并返回数据
	 * @param string $uri 请求地址
	 * @param mixed $params 请求参数
	 * @param header boolean 是否带header头
	 * @return type
	 */
	static function curlPost($uri,$params='',$header=true)
	{
		$data = is_array($params) ? http_build_query($params) : $params;
	
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $uri);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,$data);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		if($header) curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-type:application/x-www-form-urlencoded;charset=utf-8'));
		$ret = curl_exec($ch);
		if($errno = curl_errno($ch)) {
			throw new \Think\Exception('Curl Error('.$errno.'):'.curl_error($ch));
		}
		curl_close($ch);
		return $ret;
	}
}